#pragma once

#include <Cg/cg.h>

#include "../Renderer.h"

class CGShader : public Shader {
public:
	CGShader(bool vertex_shader);
	virtual ~CGShader();

	CGprogram cgProgram;
	CGprofile cgProfile;

	// set predefined variables
	virtual void setMatSpecular(const float specular[4]) const;
	virtual void setLightPos(float p1, float p2, float p3, float d1, float d2, float d3) const;
	virtual void setLightAmbient(float rf, float gf, float bf) const;
	virtual void setLightDiffuse(float rf, float gf, float bf) const;
	virtual void setLightSpecular(float rf, float gf, float bf) const;
	virtual void setLightAtten(float a, float b, float c) const;
	virtual void setBumpTexture(const Texture *texture) const;
	virtual void setHardwareAnimationAlpha(float alpha) const;
};
