#pragma once


#include <dsound.h>
#include <dshow.h>

#include "../Sound.h"

class DXSound : public Sound {
	LPDIRECTSOUND               lpds;
	DSBUFFERDESC                dsbdesc;
	LPDIRECTSOUNDNOTIFY         lpdsNotify;

	LPDIRECTSOUNDBUFFER lpdsbStatic[max_sounds_c];
	LPVOID lpvAudio[max_sounds_c];
	DWORD  dwBytes[max_sounds_c];

	UINT cbBytesRead;

	// DirectShow
	bool            has_media;
	IGraphBuilder  *pMediaGraph;
	IMediaControl  *pMediaControl;
	//IMediaEvent   *pMediaEvent;
	IMediaEventEx  *pMediaEvent;
	IMediaPosition *pMediaPosition;

	void DS_Init();
	//bool setCooperativeLevel(HWND hwnd);
public:
	//DXSound(HWND hwnd);
	DXSound();
	virtual ~DXSound();

	// interface
	virtual bool LoadSound(int s,const char *file);
	virtual bool PlaySound(int s,bool loop,int delay);
	virtual void FreeSound(int s);
	virtual bool IsSoundPlaying(int s);
	virtual void StopSound(int s,bool bResetPosition);

	virtual void playMedia(const char *filename);
	virtual bool isMediaPlaying();

	virtual void processEvents(UINT message, WPARAM wParam, LPARAM lParam);
	virtual bool initHWND(HWND hWnd);
};
