#pragma once

#include <cstdio>

class VI_Object;
class VI_VObject;
class VI_Mesh;
class VI_SceneGraphNode;
class VI_Entity;

class Object3D;
class MD2Object;
class TDS_Material;
class Mesh;

//#ifdef _WIN32 || __linux
#define ENDIANSWAPLONG(x)
#define ENDIANSWAPSHORT(x)
//#endif

class Loader {
	static void fskip(FILE *fp, int num_bytes);
	static bool fgetLine(FILE *fp, char *ptr);
	static char * stripWhiteSpace(char *ptr);
	//static void getRGBData(Image2D *image,const unsigned char *data,const rgb_struct *palette);
	//static bool read_256WAL(FILE *pic_file,Image2D * image);
	static int parse3DSChunk(FILE * file,VI_VObject *obj,TDS_Material **first_mat,void * sub);
	static int getWords(const char *str,char **words);
public:
	//static bool loadWAL(Image2D *image,const char * filename);
	static VI_VObject *import3DS(const char * filename);
	static VI_VObject *importMD2(bool all,const char * filename);
	static VI_VObject *importRWX(const char * filename);
	static VI_VObject *importVObject(const char * filename);
	static VI_Mesh *importMD2(const char *filename, const char *skinfile);
	static VI_Entity *importEntityMD2(VI_Mesh **v_obj,const char *filename,const char *texture);
	static VI_SceneGraphNode *importNodeNWN(int *n_objs,VI_Object ***objs,const char *filename);
};

/*VI_Mesh *VI_load_md2(const char *filename,const char *texture);
VI_VObject *VI_load_vobject(const char *filename);
VI_Entity *VI_load_entity_md2(VI_Object **v_obj,const char *filename,const char *texture);
VI_SceneGraphNode *VI_load_node_nwn(int *n_obj,VI_Object ***v_obj,const char *filename);*/
